<?php defined('C5_EXECUTE') or die("Access Denied.");

/**
 * Yandex Money Form package for Concrete5
 * Copyright 2020, Alex Borisov. All Rights Reserved.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author Alex Borisov <linuxoidoz@gmail.com>
 * @copyright 2018-2020, Alex Borisov. All Rights Reserved.
 * @package Concrete\Package\ab_yandex_money_form
 */

$ps = $app->make('helper/form/page_selector');
?>

<style>
input[type="checkbox"] {
    position: relative;
    top: 3px;
    margin-right: 10px !important;
}
.need {
    display: inline-block;
    text-align: left;
    margin: 0 auto;
    margin-left: 10px;
    color: #ff4100;
    font-size: 0.7em;
    font-weight: 400;
    opacity: 0.5;
}

.text-muted { font-size: 0.8em; }
</style>

<fieldset class="ab-yandex-money-form">

    <div class="form-group">
        <?php
        echo $form->label('form_title', t('Form Title'));
        echo $form->text('form_title', $form_title, ['maxlength' => 100]);
        echo '<p class="text-muted">' . t('Max 100 symbols') . '</p>';
        ?>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('btn_text', t('Submit Button text'));
        echo $form->text('btn_text', $btn_text ? $btn_text : t('Pay'), ['maxlength' => 100]);
        echo '<p class="text-muted">' . t('Max 100 symbols') . '</p>';
        ?>
    </div>
    
    <div class="form-group">
        <div class="alert alert-info" role="alert">
            <?php echo t('Required Parameters'); ?>
        </div>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('wallet', t('Yandex.Money Wallet No') . '<span class="need">' . t('Required') . '</span>');
        echo $form->text('wallet', $wallet, ['maxlength' => 20]);
        echo '<p class="text-muted">' . t('Max 20 symbols') . '</p>';
        ?>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('form_type', t('Form Type'));
        echo $form->select('form_type', $form_types, $form_type ? $form_type : 'shop');
        ?>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('payment_targets_text', t('Purpose of Payment') . '<span class="need">' . t('Required') . '</span>');
        echo $form->text('payment_targets_text', $payment_targets_text, ['maxlength' => 150]);
        echo '<p id="payment_targets_text_p" class="text-muted">' . t('Max 150 symbols') . '</p>';
        ?>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->checkbox('payment_targets_uid', 1, $payment_targets_uid ? '1' : '0');
        echo $form->label('payment_targets_uid', t('Append date-time string to Purpose of Payment'));
        echo '<p class="text-muted">' . t('e.g. Transaction') . ' ' . date('YmdHis', time()) . '</p>';
        ?>
    </div>
    
    <?php echo $form->label('payment_types', t('Payment Types')); ?>
    <div class="well">
        <div>
            <?php
            echo $form->checkbox('payment_ac', 1, $payment_ac ? '1' : '0');
            echo $form->label('payment_ac', t('Bank Card'));
            ?>
        </div>
    
        <div>
            <?php
            echo $form->checkbox('payment_pc', 1, $payment_pc ? '1' : '0');
            echo $form->label('payment_pc', t('Yandex.Money Wallet'));
            ?>
        </div>
        
        <div>
            <?php
            echo $form->checkbox('payment_mc', 1, $payment_mc ? '1' : '0');
            echo $form->label('payment_mc', t('Mobile Phone Account'));
            ?>
        </div>
        <p class="text-muted"><?php echo t('If none selected, no option will be displayed and Bank Card payment will be used by default'); ?></p>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('payment_sum', t('Payment Sum') . '<span id="payment_sum_span" class="need">' . t('Required') . '</span>');
        echo $form->text('payment_sum', $payment_sum, ['maxlength' => 10, 'class' => "decimals"]);
        echo '<p class="text-muted">' . t('Max 10 symbols, numbers only') . '</p>';
        ?>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->checkbox('allow_user_sum', 1, $allow_user_sum ? '1' : '0');
        echo $form->label('allow_user_sum', t('User can Enter/Edit Payment Sum'));
        ?>
    </div>
    
    <div class="form-group">
        <div class="alert alert-info" role="alert">
            <?php echo t('Optional Parameters'); ?>
        </div>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('payment_formcomment', t('Payment Description'));
        echo $form->text('payment_formcomment', $payment_formcomment, ['maxlength' => 50]);
        echo '<p class="text-muted">' . t('Max 50 symbols') . '</p>';
        ?>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('payment_short_dest', t('Payment Description on Confirmation'));
        echo $form->text('payment_short_dest', $payment_short_dest, ['maxlength' => 50]);
        echo '<p class="text-muted">' . t('Max 50 symbols') . '</p>';
        ?>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('payment_label_select', t('Payment Label'));
        echo $form->select('payment_label_select', $payment_labels, $payment_label_select ? $payment_label_select : 0);
        ?>
    </div>
    <div data-fields="payment_label_text" style="display: none;">
        <div class="well">
            <div>
                <?php
                echo $form->label('payment_label_text', t('Payment Label Text') . '<span id="payment_sum_span" class="need">' . t('Required') . '</span>');
                echo $form->text('payment_label_text', $payment_label_text, ['maxlength' => 64]);
                echo '<p id="payment_label_text_p" class="text-muted">' . t('Max 64 symbols') . '</p>';
                ?>
            </div>
        </div>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->checkbox('payment_comment', 1, $payment_comment ? '1' : '0');
        echo $form->label('payment_comment', t('Show Payment Comment'));
        ?>
    </div>
    
    <?php echo $form->label('personal_info', t('Required Personal Info')); ?>
    <div class="well">
        <div>
            <?php
            echo $form->checkbox('need_fio', 1, $need_fio ? '1' : '0');
            echo $form->label('need_fio', t('Name'));
            ?>
        </div>
        
        <div>
            <?php
            echo $form->checkbox('need_email', 1, $need_email ? '1' : '0');
            echo $form->label('need_email', t('Email'));
            ?>
        </div>
        
        <div>
            <?php
            echo $form->checkbox('need_phone', 1, $need_phone ? '1' : '0');
            echo $form->label('need_phone', t('Phone'));
            ?>
        </div>
        
        <div>
            <?php
            echo $form->checkbox('need_address', 1, $need_address ? '1' : '0');
            echo $form->label('need_address', t('Address'));
            ?>
        </div>
        <p class="text-muted"><?php echo t('Better ask for user data if really required to avoid user filling unnecessary fields'); ?></p>
    </div>
    
    <div class="form-group">
        <?php
        echo $form->label('success_url_page_id', t('Page for Successful Payment'));
        echo $ps->selectPage('success_url_page_id', $success_url_page_id);
        ?>
    </div>
    
    <p class="text-muted"><?php echo t('Ref.'); ?> <strong><a href="https://yandex.ru/dev/money/doc/payment-buttons/reference/forms-docpage" target="_blank"><?php echo t('Yandex.Money API'); ?></a></strong> <?php echo t('for more detail'); ?></p>
    
    <?php echo $form->hidden('decimals_error', '', ['data-error-title' => t('Oops!'), 'data-error-message' => t('Numbers only')]); ?>
    
</fieldset>

<script type="text/javascript">
$(function() {
    var payment_label_select = $('#payment_label_select');
    var payment_label_text = $('#payment_label_text');
    var payment_label_text_p = $('#payment_label_text_p');
    
    $(document).on('change', '#payment_label_select', function() {
        var payment_label_text_div = $('div[data-fields=payment_label_text]');
        
        switch(payment_label_select.val()) {
            case '0':
                payment_label_text_div.show();
                payment_label_text_p.text('<?php echo t('Max 64 symbols'); ?>');
                break;
            case '1':
                payment_label_text_div.show();
                payment_label_text_p.text('<?php echo t('Max 50 symbols'); ?>');
                break;
            case '2':
                payment_label_text_div.show();
                payment_label_text_p.text('<?php echo t('Max 49 symbols'); ?>');
                break;
            case '3':
                payment_label_text_div.hide();
                payment_label_text.val('');
                payment_label_text_p.text('');
                break;
            case '4':
                payment_label_text_div.hide();
                payment_label_text.val('');
                payment_label_text_p.text('');
                break;
        }
    });
    payment_label_select.trigger('change');
    
    $('#payment_targets_uid').on('change', function() {
        $('#payment_targets_text_p').text($(this).is(':checked') ? '<?php echo t('Max 135 symbols'); ?>' : '<?php echo t('Max 150 symbols'); ?>');
    }).trigger('change');
        
    $('#allow_user_sum').on('change', function() {
        $(this).is(':checked') ? $('#payment_sum_span').hide() : $('#payment_sum_span').show();
    }).trigger('change');
        
    $('#ccm-form-submit-button').on('click', function(e) {
        var form_title = $.trim($('#form_title').val());
        var btn_text = $.trim($('#btn_text').val());
        var wallet = $.trim($('#wallet').val());
        var payment_targets_text = $.trim($('#payment_targets_text').val());
        var payment_targets_uid = $('#payment_targets_uid').is(':checked');
        var payment_sum = $.trim($('#payment_sum').val());
        var allow_user_sum = $('#allow_user_sum').is(':checked');
        var payment_formcomment = $.trim($('#payment_formcomment').val());
        var payment_short_dest = $.trim($('#payment_short_dest').val());
        var payment_label_select_value = $.trim(payment_label_select.val());
        var payment_label_text_value = $.trim(payment_label_text.val());
        
        if (wallet == '' || wallet.length > 20) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Yandex.Money Wallet No error:')); ?>,
                message: <?php echo json_encode(t('Yandex.Money Wallet No cannot be empty and must have max 20 symbols')); ?>
            });
        }
        else if (payment_targets_text == '' || payment_targets_text.length > 150) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Purpose of Payment error:')); ?>,
                message: <?php echo json_encode(t('Purpose of Payment cannot be empty and must have max 150 symbols')); ?>
            });
        }
        else if (payment_targets_uid && payment_targets_text.length > 135) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Purpose of Payment error:')); ?>,
                message: <?php echo json_encode(t('Purpose of Payment must have max 135 symbols if date-time string is appended')); ?>
            });
        }
        else if (!allow_user_sum && payment_sum == '') {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Payment Sum error:')); ?>,
                message: <?php echo json_encode(t('Payment Sum cannot be empty')); ?>
            });
        }
        else if (payment_sum.length > 10) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Payment Sum error:')); ?>,
                message: <?php echo json_encode(t('Payment Sum must have max 10 symbols')); ?>
            });
        }
        else if (form_title.length > 100) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Form Title error:')); ?>,
                message: <?php echo json_encode(t('Form Title must have max 100 symbols')); ?>
            });
        }
        else if (btn_text.length > 100) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Button Text error:')); ?>,
                message: <?php echo json_encode(t('Button Text must have max 100 symbols')); ?>
            });
        }
        else if (payment_formcomment.length > 50) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Payment Description error:')); ?>,
                message: <?php echo json_encode(t('Payment Description must have max 50 symbols')); ?>
            });
        }
        else if (payment_short_dest.length > 50) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Payment Description on Confirmation error:')); ?>,
                message: <?php echo json_encode(t('Payment Description on Confirmation must have max 50 symbols')); ?>
            });
        }
        else if (payment_label_select_value == 0 && (payment_label_text_value == '' || payment_label_text_value.length > 64)) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Payment Label Text error:')); ?>,
                message: <?php echo json_encode(t('Payment Label Text must have max 64 symbols')); ?>
            });
        }
        else if (payment_label_select_value == 1 && payment_label_text_value.length > 50) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Payment Label Text error:')); ?>,
                message: <?php echo json_encode(t('Payment Label Text must have max 50 symbols')); ?>
            });
        }
        else if (payment_label_select_value == 2 && payment_label_text_value.length > 49) {
            e.preventDefault();
            e.stopPropagation();
            ConcreteAlert.error({
                title: <?php echo json_encode(t('Payment Label Text error:')); ?>,
                message: <?php echo json_encode(t('Payment Label Text must have max 49 symbols')); ?>
            });
        }
    });
    
    var error_title = $('#decimals_error').attr('data-error-title');
    var error_message = $('#decimals_error').attr('data-error-message');
    var ctrl_key_pressed = false;
    $('.decimals').keydown(function (e) {
        if (e.ctrlKey === true || e.metaKey === true) {
            ctrl_key_pressed = true;
        }
        // Allow: ctrl, backspace, delete, tab, escape, enter, - and .
        if ($.inArray(e.keyCode, [17, 8, 46, 9, 27, 13, 109, 173, 110, 190]) !== -1 ||
             // Allow: Ctrl+A, Ctrl+C, Ctrl+V
            (ctrl_key_pressed && (e.keyCode == 65 || e.keyCode == 67 || e.keyCode == 86)) || 
             // Allow: home, end, left, right, down, up
            (e.keyCode >= 35 && e.keyCode <= 40)) {
                 // let it happen, don't do anything
                 ctrl_key_pressed = false;
                 return;
        }
        // Ensure that it is a number and stop the keypress
        if ((e.shiftKey || (e.keyCode < 48 || e.keyCode > 57)) && (e.keyCode < 96 || e.keyCode > 105)) {
            e.preventDefault();
            ConcreteAlert.error({
                title: error_title,
                message: error_message,
            });
        }
    });
});
</script>
