<?php

/**
 * Yandex Money Form package for Concrete5
 * Copyright 2020, Alex Borisov. All Rights Reserved.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author Alex Borisov <linuxoidoz@gmail.com>
 * @copyright 2018-2020, Alex Borisov. All Rights Reserved.
 * @package Concrete\Package\ab_yandex_money_form
 */

namespace Concrete\Package\AbYandexMoneyForm;

use Concrete\Core\Package\Package;
use Concrete\Core\Block\BlockType\BlockType;

class Controller extends Package {

	protected $pkgHandle = 'ab_yandex_money_form';
	protected $appVersionRequired = '8.3.2';
	protected $pkgVersion = '0.9.1';
	
	public function getPackageDescription() 
	{
		return t('Add Yandex Money Form');
	}
	
	public function getPackageName() 
	{
		return t('Yandex Money Form');
	}
	
	public function install() 
	{
		$pkg = parent::install();
		BlockType::installBlockType('ab_yandex_money_form', $pkg);
	}

}
